import swc from "npm:@swc/wasm@1.3.35";
import { resolveNode } from "../index.ts";

export default function BlockStatement(
  node: swc.Node,
  variablesTable: VariablesTableType,
  variableModificationThings: VariablesThingType,
  prc: { count: number },
  instructions: string[],
) {
  const typedNode = node as swc.BlockStatement;

  const oldVariableTable = { ...variablesTable };

  for (
    const node of typedNode.stmts
  ) {
    console.log(node);
    instructions.push(
      ...resolveNode(
        node,
        prc,
        variableModificationThings,
        variablesTable,
      ),
    );
  }

  for (const key of Object.keys(variablesTable)) {
    if (!oldVariableTable[key]) {
      variableModificationThings.freeVariable(key);
    }
  }
}
